<script setup lang="ts">
import { defineProps, PropType } from 'vue';
import { Editor } from '@tiptap/vue-3';
import { JIcon } from '@new-jira-clone/ui/src/components';
import WVerticalSeparator from './WVerticalSeparator.vue';
import WButton from './WButton.vue';

defineProps({
  editor: {
    type: Object as PropType<Editor>,
    required: true,
  },
});
</script>

<template>
  <div class="w-editor-toolbar">
    <WButton
      class="w-button"
      title="Bold"
      :active="editor?.isActive('bold')"
      @click="editor.chain().focus().toggleBold().run()"
      @keydown.space="editor.chain().focus().toggleBold().run()"
      @keydown.enter="editor.chain().focus().toggleBold().run()"
    >
      <JIcon container-size size="16px" icon="bold" />
    </WButton>
    <WButton
      class="w-button"
      title="Italic"
      :active="editor?.isActive('italic')"
      @click="editor.chain().focus().toggleItalic().run()"
    >
      <JIcon container-size size="16px" icon="italic" />
    </WButton>
    <WButton
      class="w-button"
      title="Underline"
      :active="editor?.isActive('underline')"
      @click="editor.chain().focus().toggleUnderline().run()"
    >
      <JIcon container-size size="16px" icon="underline" />
    </WButton>
    <WButton
      class="w-button"
      title="Strike"
      :active="editor?.isActive('strike')"
      @click="editor.chain().focus().toggleStrike().run()"
    >
      <JIcon container-size size="16px" icon="strike" />
    </WButton>

    <WVerticalSeparator />

    <WButton
      class="w-button"
      title="text-left"
      @click="editor.chain().focus().setTextAlign('left').run()"
    >
      <JIcon container-size size="16px" icon="alignLeft" />
    </WButton>
    <WButton
      class="w-button"
      title="text-center"
      @click="editor.chain().focus().setTextAlign('center').run()"
    >
      <JIcon container-size size="16px" icon="alignCenter" />
    </WButton>
    <WButton
      class="w-button"
      title="text-right"
      @click="editor.chain().focus().setTextAlign('right').run()"
    >
      <JIcon container-size size="16px" icon="alignRight" />
    </WButton>

    <WVerticalSeparator />

    <WButton
      class="w-button"
      title="Code"
      :active="editor?.isActive('code')"
      @click="editor.chain().focus().toggleCode().run()"
    >
      <JIcon container-size size="16px" icon="code" />
    </WButton>
  </div>
</template>

<style lang="scss" sscoped>
.w-editor-toolbar {
  display: flex;
  align-items: center;
  gap: 6px;
  padding: 8px;
  padding-bottom: 6px;
}
</style>
